
#ifndef _EDITOR_H
#define _EDITOR_H


#include <Window.h>
#include <ListItem.h>
#include <ListView.h>
#include <ScrollView.h>
#include "Playlist.h"
#include "pluginproto.h"
#include <iostream>
#include <Messenger.h>
#include <cctype>
#include <MessageRunner.h>
#include <Font.h>

#include "ProgBar.h"

#include "VolBar.h"

const uint32 RUNR = 'runr';
const int UPDATE_TIME = 100000;
#include <Button.h>

const uint32 SORT_NAME = 'srtn';
const uint32 SORT_PATH = 'srtp';
const uint32 RANDOMIZE = 'rdom';
const uint32 REMOVE = 'rmve';
const uint32 REMOVE_ALL = 'rall';
const uint32 PLAY = 'play';
const uint32 PAUSE = 'paws';
const uint32 PLAYPREV = 'plyp';
const uint32 PLAYNEXT = 'plyn';
const uint32 SCROLLTOSELECTION = 'scts';

//const uint32 SAVE_AS = 'svas';

class PlayListItem: public BListItem
{
	public:
		int32 id;
		PlayListItem(int32 itemid, const char *name,bool IsEven/*,double l*/);
		void SetLabel(const char* l);
		virtual void DrawItem(BView* owner,BRect frame,bool complete=false);
		BString Label();
		//void Play();
	private:
		BString label;
		rgb_color ItemColor;
		//double length;
	//	BString duration;
	
};

class PlayListView : public BListView
{
	public:
		PlayListView(BRect frame);
		virtual void SelectionChanged();
		virtual void AttachedToWindow();
		virtual void KeyDown(const char* bytes,int32 numBytes);
		//void Select(int32 index,bool IsManual,bool extend=false);
		virtual void MouseDown(BPoint point);
	private:
		void HotKeySelect(char c);
		uint32 button;	//last button pressed down
		//bool OkToSend;
};
class Editor: public BWindow
{
friend class PlaylistEditorWatcher;
	private:
		PlaylistPtr playlist;
		PlayListView*	lv;
		void Populate();
		void MakeEmpty();
		
	public:
		//BMessenger RemoteTrack(int32 index);
		Editor(PlaylistPtr pl);
		BMessenger	remoteapp;
		virtual void FrameResized(float width,float height);
		virtual void FrameResized(BPoint point);
		
		virtual void MessageReceived(BMessage *mes);
		BButton* sort_name;
		BButton* sort_path;
		BButton* randomize;
		BButton* remove;
		BButton* remove_all;
		BButton* play;
		BButton* paws;
		BButton* plyp;
		BButton* plyn;
		BButton* scrolltoselection;
		BMessageRunner* volRunner;
		VolBar* vol;
		ProgBar* prog;
};



#endif
