#include "ProgBar.h"
ProgBar::ProgBar(BRect frame) : BStatusBar(frame,"ProgBar")
{
	SetResizingMode(B_FOLLOW_TOP|B_FOLLOW_RIGHT);
	SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	SetLowColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	OkToChangeProg = false;
}
/*void ProgBar::Draw(BRect updateRect)
{	
	Render();
}*/
//void ProgBar::Draw(BRect updateRect)//Render()
//{
//	BRect r = Bounds();
//	BStatusBar::Draw(updateRect);
/*	label = "";
	int seconds = int(CurrentValue());
	int minutes = seconds / 60;
	seconds = seconds % 60;
	//int minutes = int(CurrentValue()/60);
	//int seconds = (int(CurrentValue()) - minutes)/60;
	if(minutes < 10 && seconds >= 10)
		label << "0" << (int)minutes << ":" << (int)seconds;
	else if(minutes < 10 && seconds < 10)
		label << "0" << (int)minutes << ":0" << (int)seconds;
	else if(minutes >= 10 && seconds < 10)
		label << (int)minutes << ":0" << (int)seconds;
	else
		label << (int)minutes << ":" << (int)seconds;
	
	BFont font(be_bold_font);
	font.SetSize(12);
	SetFont(&font);
	MovePenTo((r.Width()-font.StringWidth(label.String()))/2,r.Height()-6);
	SetDrawingMode(B_OP_ALPHA);
	SetLowColor(0,0,0,0);
	SetHighColor(0,0,0,255);
	DrawString(label.String());
*/

//}
void ProgBar::Update(float delta,const char* text=NULL,const char* trailingText=NULL)
{
	BStatusBar::Update(delta,text,trailingText);
	label = "Time: ";
	int seconds = int(CurrentValue());
	int minutes = seconds / 60;
	seconds = seconds % 60;
	//int minutes = int(CurrentValue()/60);
	//int seconds = (int(CurrentValue()) - minutes)/60;
	if(minutes < 10 && seconds >= 10)
		label << "0" << (int)minutes << ":" << (int)seconds;
	else if(minutes < 10 && seconds < 10)
		label << "0" << (int)minutes << ":0" << (int)seconds;
	else if(minutes >= 10 && seconds < 10)
		label << (int)minutes << ":0" << (int)seconds;
	else
		label << (int)minutes << ":" << (int)seconds;
	
	SetText(label.String());
	//Invalidate();
}
void ProgBar::MouseUp(BPoint point)
{
	OkToChangeProg = false;
}
void ProgBar::MouseDown(BPoint point)
{
	uint32 button;
	GetMouse(&point,&button);
	if(button == B_PRIMARY_MOUSE_BUTTON)
	{
		
		BRect r = Bounds();
		BRect BarRect(r.left,r.bottom-5-14,r.right-2,r.bottom-5);
		if(BarRect.Contains(point))
		{
			OkToChangeProg = true;
			SetEventMask(B_POINTER_EVENTS);
			//point.PrintToStream();
			float MaxVal = MaxValue();
			float pos = point.x/BarRect.Width()*MaxVal;
			float cur = CurrentValue();
			if(pos < 0)
				pos = 0;
			if(pos > MaxVal)
				pos = MaxVal;
			
			BMessage msg(REQUEST_PROG_CHANGE);
			
			if(pos > cur)
			{
				Update(pos - cur);
				if(msg.AddFloat("prog",pos) == B_OK)
				Window()->PostMessage(&msg);
			}
			else if(pos < cur)
			{
				Update(-(cur - pos));
				if(msg.AddFloat("prog",pos) == B_OK)
				Window()->PostMessage(&msg);
			}			
		}
	}
	BStatusBar::MouseDown(point);
}
void ProgBar::MouseMoved(BPoint point,uint32 transit,const BMessage* message)
{
	uint32 button;
	GetMouse(&point,&button);
	if(button == B_PRIMARY_MOUSE_BUTTON)
	{
		BRect r = Bounds();
		BRect BarRect(r.left,r.bottom-5-14,r.right-2,r.bottom-5);
		if(OkToChangeProg)//BarRect.Contains(point))
		{
			float MaxVal = MaxValue();
			float pos = point.x/BarRect.Width()*MaxVal;
			float cur = CurrentValue();
			if(pos < 0)
				pos = 0;
			if(pos > MaxVal)
				pos = MaxVal;

			BMessage msg(REQUEST_PROG_CHANGE);
			if(pos > cur)
			{
				Update(pos - cur);
				if(msg.AddFloat("prog",pos) == B_OK)
				Window()->PostMessage(&msg);
			}
			else if(pos < cur)
			{
				Update(-(cur - pos));
				if(msg.AddFloat("prog",pos) == B_OK)
				Window()->PostMessage(&msg);
			}			

		}
	}
	BStatusBar::MouseMoved(point,transit,message);
}
void ProgBar::AttachedToWindow()
{
	Parent()->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	SetBarColor(ui_color(B_WINDOW_TAB_COLOR));
	SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	SetBarHeight(18);
	BFont font(be_bold_font);
	font.SetSize(12);
	SetFont(&font);

}