#include "VolBar.h"
VolBar::VolBar(BRect frame) : BStatusBar(frame,"VolBar")
{
	SetResizingMode(B_FOLLOW_TOP|B_FOLLOW_RIGHT);
	OkToChangeVol = false;
}
/*void VolBar::Draw(BRect updateRect)
{
	BStatusBar::Draw(updateRect);
	BRect r = Bounds();
	label = "";
	label << int(CurrentValue()*100) << "%";
	BFont font(be_bold_font);
	font.SetSize(12);
	SetFont(&font);
	MovePenTo((r.Width()-font.StringWidth(label.String()))/2,r.Height()-6);
	SetDrawingMode(B_OP_ALPHA);
	SetLowColor(0,0,0,0);
	SetHighColor(0,0,0,255);
	DrawString(label.String());
}*/
void VolBar::Update(float delta,const char* text=NULL,const char* trailingText=NULL)
{
	BStatusBar::Update(delta,text,trailingText);
	//Invalidate();
	label = "Vol: ";
	label << int(CurrentValue()*100) << "%";
	SetText(label.String());

}
void VolBar::MouseUp(BPoint point)
{
	OkToChangeVol = false;
}
void VolBar::MouseDown(BPoint point)
{
	uint32 button;
	GetMouse(&point,&button);
	if(button == B_PRIMARY_MOUSE_BUTTON)
	{
		
		BRect r = Bounds();
		BRect BarRect(r.left,r.bottom-5-14,r.right-2,r.bottom-5);
		if(BarRect.Contains(point))
		{
			OkToChangeVol = true;
			SetEventMask(B_POINTER_EVENTS);
			//point.PrintToStream();
			float pos = point.x/BarRect.Width()*2;
			float cur = CurrentValue();
			if(pos < 0)
				pos = 0;
			if(pos > 2)
				pos = 2;
			
			BMessage msg(REQUEST_VOL_CHANGE);
			
			if(pos > cur)
			{
				Update(pos - cur);
				if(msg.AddFloat("vol",pos) == B_OK)
				Window()->PostMessage(&msg);
			}
			else if(pos < cur)
			{
				Update(-(cur - pos));
				if(msg.AddFloat("vol",pos) == B_OK)
				Window()->PostMessage(&msg);
			}			
		}
	}
	BStatusBar::MouseDown(point);
}
void VolBar::MouseMoved(BPoint point,uint32 transit,const BMessage* message)
{
	uint32 button;
	GetMouse(&point,&button);
	if(button == B_PRIMARY_MOUSE_BUTTON)
	{
		BRect r = Bounds();
		BRect BarRect(r.left,r.bottom-5-14,r.right-2,r.bottom-5);
		if(OkToChangeVol)//BarRect.Contains(point))
		{
			//point.PrintToStream();
			float pos = point.x/BarRect.Width()*2;
			float cur = CurrentValue();
			if(pos < 0)
				pos = 0;
			if(pos > 2)
				pos = 2;

			BMessage msg(REQUEST_VOL_CHANGE);
			
			if(pos > cur)
			{
				Update(pos - cur);
				if(msg.AddFloat("vol",pos) == B_OK)
				Window()->PostMessage(&msg);
			}
			else if(pos < cur)
			{
				Update(-(cur - pos));
				if(msg.AddFloat("vol",pos) == B_OK)
				Window()->PostMessage(&msg);
			}			

		}
	}
	BStatusBar::MouseMoved(point,transit,message);
}
void VolBar::AttachedToWindow()
{
	SetBarColor(ui_color(B_WINDOW_TAB_COLOR));
	SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	SetLowColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	SetMaxValue(2.0);
	SetBarHeight(18);
	BFont font(be_bold_font);
	font.SetSize(12);
	SetFont(&font);

}